unit uOszilloskop0;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, mTLeitung;

const
  px_s = 10; // Pixel pro Sekunde
  y1   = 20; // "Hhe" der 1 in Pixel

type
  TForm1 = class(TForm)
    bTaster: TButton; shLed: TShape; Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bTasterMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bTasterMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
  private
    x,y,y0  : integer;
    t       : real;
    leitung : TLeitung;
    procedure updateLed;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  leitung := TLeitung.Create;
  t := 0; y0 := 80; x := round(t);
  if leitung.GetZustand then y := y0-y1 else y := y0;
  canvas.MoveTo(x,y);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  leitung.Free;
end;

procedure TForm1.updateLed;
begin
  if leitung.GetZustand
  then shLed.Brush.Color := clRed
  else shLed.Brush.Color := clMaroon;
end;

procedure TForm1.bTasterMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  leitung.SetZustand(true);
  updateLed;
end;

procedure TForm1.bTasterMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  leitung.SetZustand(false);
  updateLed;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if x > width then
  begin
    t := 0; x := Round(t); y0 := y0+y1+10;
    if leitung.GetZustand then canvas.MoveTo(x,y0-y1)
                          else canvas.MoveTo(x,y0);
  end;
  if leitung.GetZustand then y := y0-y1 else y := y0;
  x := Round(t); canvas.LineTo(x,y);
  t := t+Timer1.Interval*0.001*px_s;
end;

end.
